diff --git a/Client/Client/Assets/Scripts/RushManager.cs b/Client/Client/Assets/Scripts/RushManager.cs
new file mode 100644
index 0000000..94d3b50
--- /dev/null
+++ b/Client/Client/Assets/Scripts/RushManager.cs
@@ -0,0 +1,211 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+
+public class RushManager : MonoBehaviour
+{
+    private DateTimeManager dateTimeManager;
+    private WeatherManager weatherManager;
+    public NetworkingManager networkingManager;
+    public MapRenderer mapRenderer;
+
+    private Request request;
+    private Response response;
+
+    private Prediction currentPrediction;
+    public int predictionIndex;
+
+    public bool playing = false;
+    private bool loading = false;
+
+    public Animator loadingAnimator;
+
+    public float timePerSegment = 1f;
+    public float timer;
+
+    // Start is called before the first frame update
+    void Start()
+    {
+        dateTimeManager = GetComponent<DateTimeManager>();
+        weatherManager = GetComponent<WeatherManager>();
+    }
+
+    // Update is called once per frame
+    void Update()
+    {
+        // No request made yet, no response received
+        // If there is no request and no response, new request should be made
+        if (request == null && response == null)
+        {
+            request = new Request();
+            request.start = dateTimeManager.currentDate;
+            weatherManager.SetWeather(request);
+            networkingManager.StartPost(request);
+        }
+        
+        // No request, response received - playing animation
+        else if (request == null && response != null)
+        {
+            if (loading)
+            {
+                loading = false;
+                if (loadingAnimator != null) 
+                    loadingAnimator.SetBool("loading", loading);
+            }
+
+            if (playing)
+            {
+                timer -= Time.deltaTime;
+                if (timer < 0)
+                {
+                    timer = timePerSegment;
+
+                    if (predictionIndex + 1 < response.predicitons.Length)
+                    {
+                        Next();
+                        playing = true; //  Correct for Next() setting playing = false
+                    }
+                    else
+                    {
+                        playing = false;
+                    }
+                }
+            }
+        }
+
+        // Request made, waiting for response
+        else if (request != null && response == null)
+        {
+            // Play loading animation
+            if (!loading)
+            {
+                loading = true;
+                if (loadingAnimator != null) 
+                    loadingAnimator.SetBool("loading", loading);
+                mapRenderer.SetColors(new double[Buildings.buildings.Length]);
+            }
+            Debug.Log("Loading...");
+        }
+
+        else if (request != null && response != null)
+        {
+            Debug.LogError("Coexisting request and response. This should never happen.");
+        }
+
+    }
+
+    public void SetResponse(Response response)
+    {
+        this.request = null;
+        this.response = response;
+        currentPrediction = response.predicitons[0];
+        predictionIndex = 0;
+        Redraw();
+    }
+
+    public void CreateRequest(Date startDate, Date endDate)
+    {
+        this.response = null;
+        
+        request = new Request();
+        request.start = startDate;
+        request.useEndDate = endDate != null;
+        request.end = endDate;
+
+        weatherManager.SetWeather(request);
+        networkingManager.StartPost(request);
+    }
+
+    public void Play(bool play)
+    {
+        // Works as a play/pause toggle
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+        playing = play;
+        timer = timePerSegment;
+
+        if (predictionIndex + 1 == response.predicitons.Length)
+        {
+            predictionIndex = 0;
+            currentPrediction = response.predicitons[0];
+            Redraw();
+        }
+    }
+
+    public void First()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+
+        playing = false;
+        currentPrediction = response.predicitons[0];
+        predictionIndex = 0;
+        Redraw();
+    }
+
+    public void Last()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+
+        playing = false;
+        currentPrediction = response.predicitons[response.predicitons.Length - 1];
+        predictionIndex = response.predicitons.Length - 1;
+        Redraw();
+    }
+
+    public void Previous()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+        
+        playing = false;
+
+        int newIndex = predictionIndex - 1;
+
+        if (newIndex == -1)
+            return;
+        predictionIndex = newIndex;
+        currentPrediction = response.predicitons[predictionIndex];
+        Redraw();
+    }
+
+    public void Next()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return; }
+        
+        playing = false;
+
+        int newIndex = predictionIndex + 1;
+        if (newIndex == response.predicitons.Length)
+            return;
+        predictionIndex = newIndex;
+        currentPrediction = response.predicitons[predictionIndex];
+        Redraw();
+    }
+
+    public void ResetRush()
+    {
+        playing = false;
+        response = null;
+        currentPrediction = null;
+        predictionIndex = -1;
+        // If there is no request and no response, new request should be made in Update
+    }
+
+    public float GetProgress()
+    {
+        if (response == null) { Debug.LogError("Trying to access null response/prediction."); return 0f; }
+
+        if ((response.predicitons.Length - 1) == 0) return 1.0f;
+        return predictionIndex / (float)(response.predicitons.Length - 1);
+    }
+
+    private void Redraw()
+    {
+        var firstPred = response.predicitons[0];
+        var lastPred = response.predicitons[response.predicitons.Length-1];
+
+        dateTimeManager.SetDates(currentPrediction.dateTime, firstPred.dateTime, lastPred.dateTime);
+        // TODO update weather
+        mapRenderer.SetColors(currentPrediction.predictions);
+    }
+
+}
diff --git a/Client/Client/Assets/Scripts/RushManager.cs.meta b/Client/Client/Assets/Scripts/RushManager.cs.meta
new file mode 100644
index 0000000..18e0dbe
--- /dev/null
+++ b/Client/Client/Assets/Scripts/RushManager.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 7aaba704d6fddc649b36d23259367344
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/UI/AnimationPanel.cs b/Client/Client/Assets/Scripts/UI/AnimationPanel.cs
index 208ad15..b79de43 100644
--- a/Client/Client/Assets/Scripts/UI/AnimationPanel.cs
+++ b/Client/Client/Assets/Scripts/UI/AnimationPanel.cs
@@ -7,8 +7,7 @@ using UnityEngine.UI;
 public class AnimationPanel : MonoBehaviour, DateTimeObserver
 {
     public DateTimeManager dateTimeManager;
-    public WeatherManager weatherManager;
-    public MapRenderer mapRenderer;
+    public RushManager rushManager;
 
     public Text startDateText;
     public Text startTimeText;
@@ -38,22 +37,21 @@ public class AnimationPanel : MonoBehaviour, DateTimeObserver
     {
         if (playing)
         {
-            slider.value += Time.deltaTime * 0.2f;
-            if (slider.value >= 1) { 
-                playing = false;
-                playImage.sprite = playSprite;
+            slider.value = rushManager.GetProgress();
+            if (slider.value >= 1) {
+                playing = !playing;
+                playImage.sprite = playing ? pauseSprite : playSprite;
             }
             slider.value = Mathf.Min(Mathf.Max(0, slider.value), 1);
-            mapRenderer.Animate(slider.value);
         }
     }
 
-    public void Notify(Date startDate, Date endDate)
+    public void Notify(Date startDate, Date currentDate, Date endDate)
     {
-        startDateText.text = $"{startDate.month} / {startDate.day} / {startDate.year}";
+        startDateText.text = $"{currentDate.month} / {currentDate.day} / {currentDate.year}";
         endDateText.text = $"{endDate.month} / {endDate.day} / {endDate.year}";
 
-        startTimeText.text = $"{startDate.hour}:00";
+        startTimeText.text = $"{currentDate.hour}:00";
         endTimeText.text = $"{endDate.hour}:00";
     }
 
@@ -61,25 +59,51 @@ public class AnimationPanel : MonoBehaviour, DateTimeObserver
     {
         playing = !playing;
         playImage.sprite = playing ? pauseSprite : playSprite;
+        rushManager.Play(playing);
+        slider.value = rushManager.GetProgress();
     }
 
     public void OnToStartButtonPressed()
     {
-        slider.value = 0;
-        mapRenderer.Animate(slider.value);
+        if (playing)
+            OnPlayButtonPressed();
+
+        rushManager.First();
+        slider.value = rushManager.GetProgress();
     }
 
     public void OnToEndButtonPressed()
     {
-        slider.value = 1;
-        mapRenderer.Animate(slider.value);
+        if (playing)
+            OnPlayButtonPressed();
+
+        rushManager.Last();
+        slider.value = rushManager.GetProgress();
     }
 
-    public void Reset()
+    public void OnPreviousButtonPressed()
+    {
+        if (playing)
+            OnPlayButtonPressed();
+
+        rushManager.Previous();
+        slider.value = rushManager.GetProgress();
+    }
+
+    public void OnNextButtonPressed()
+    {
+        if (playing)
+            OnPlayButtonPressed();
+
+        rushManager.Next();
+        slider.value = rushManager.GetProgress();
+    }
+
+    public void ResetPanel()
     {
-        slider.value = 0;
-        mapRenderer.Animate(slider.value);
         playImage.sprite = playSprite;
         playing = false;
+        slider.value = 0;
+        rushManager.ResetRush();
     }
 }
diff --git a/Client/Client/Assets/Scripts/UI/DatePanel.cs b/Client/Client/Assets/Scripts/UI/DatePanel.cs
index 6cec1d9..54e5262 100644
--- a/Client/Client/Assets/Scripts/UI/DatePanel.cs
+++ b/Client/Client/Assets/Scripts/UI/DatePanel.cs
@@ -8,6 +8,7 @@ public class DatePanel : PopUpPanel
 {
     public DateTimeManager dateTimeManager;
     public AnimationPanel animationPanel;
+    public RushManager rushManager;
 
     public Toggle endTimeToggle;
     public Toggle weatherToggle;
@@ -101,20 +102,25 @@ public class DatePanel : PopUpPanel
             endDate.hour = startDate.hour;
         }
 
-        animationPanel.gameObject.SetActive(true);
+        animationPanel.gameObject.SetActive(endTimeToggle.isOn);
         dateTimeManager.SetDates(startDate, startDate, endDate);
         setDate.gameObject.SetActive(false);
         resetDate.gameObject.SetActive(true);
+
+        // HANDLE SETTING THE WEATHER
+        rushManager.CreateRequest(startDate, (endTimeToggle.isOn) ? endDate : null);
+
         OnExitButtonClicked();
     }
 
     public void OnResetDateButtonPressed()
     {
         dateTimeManager.ResetDate();
-        animationPanel.Reset();
+        animationPanel.ResetPanel();
         animationPanel.gameObject.SetActive(false);
         setDate.gameObject.SetActive(true);
         resetDate.gameObject.SetActive(false);
+        rushManager.ResetRush();
     }
 
     private bool IsValid(string text)
diff --git a/Client/Client/Assets/Scripts/UI/WeatherPanel.cs b/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
index 8c68719..c5be4da 100644
--- a/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
+++ b/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
@@ -1,4 +1,5 @@
-﻿using System.Collections;
+﻿using ServerApp.Parser.OutputInfo;
+using System.Collections;
 using System.Collections.Generic;
 using UnityEngine;
 using UnityEngine.UI;
@@ -41,7 +42,7 @@ public class WeatherPanel : PopUpPanel
 
     public void OnSetWeatherButtonPressed()
     {
-        WeatherCondition weatherValue = (WeatherCondition)weatherIndex;
+        WeatherConditions weatherValue = (WeatherConditions)weatherIndex;
 
         if (temperature.text.Length == 0)
         {
diff --git a/Client/Client/Assets/Scripts/Weather/Parser.meta b/Client/Client/Assets/Scripts/Weather/Parser.meta
new file mode 100644
index 0000000..de09cdc
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser.meta
@@ -0,0 +1,8 @@
+fileFormatVersion: 2
+guid: 154f8bcc67bf6ab4a868eb4d383f9683
+folderAsset: yes
+DefaultImporter:
+  externalObjects: {}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs b/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs
new file mode 100644
index 0000000..31c8058
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs
@@ -0,0 +1,32 @@
+﻿//
+// Author: A. Konig
+//
+
+using ServerApp.Parser.OutputInfo;
+using System.Collections.Generic;
+
+namespace ServerApp.WeatherPredictionParser
+{
+    /// <summary>
+    /// Abstract class that every Json parser should inherit from
+    /// </summary>
+    abstract class IJsonParser
+    {
+
+        /// <summary> Current weather </summary>
+        WeatherInfo current;
+        public WeatherInfo Current { get => current; }
+
+        /// <summary> Prediction for today, tommorrow and day after tommorrow </summary>
+        List<WeatherInfo> predictions;
+        public List<WeatherInfo> Predictions { get => predictions; set => predictions = value; }
+
+        /// <summary>
+        /// Parse weather prediction
+        /// Results is in attributes current for current weather and pred for weather prediction for today, tommorrow and day after tommorrow
+        /// </summary>
+        abstract public void ParsePrediction();
+
+    }
+
+}
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs.meta b/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs.meta
new file mode 100644
index 0000000..19f3f4f
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 3b38b0e994ea5ff479b58e9a0e59fc22
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs b/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs
new file mode 100644
index 0000000..5a860b4
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs
@@ -0,0 +1,407 @@
+﻿//
+// Author: A. Konig
+//
+
+using ServerApp.Parser.OutputInfo;
+using System;
+using System.Collections.Generic;
+using System.Globalization;
+using System.IO;
+using System.Net;
+using System.Text.Json;
+using UnityEngine;
+using static System.Text.Json.JsonElement;
+
+namespace ServerApp.WeatherPredictionParser
+{
+    /// <summary>
+    /// Class representing a parser for json prediction data
+    /// </summary>
+    /// <author>A. Konig</author>
+    class JsonParser : IJsonParser
+    {
+        /// <summary> Current weather </summary>
+        WeatherInfo current;
+        public new WeatherInfo Current { get => current; }
+        /// <summary> Prediction for today, tommorrow and day after tommorrow </summary>
+        List<WeatherInfo> predictions;
+        public new List<WeatherInfo> Predictions { get => predictions; set => predictions = value; }
+
+        /// <summary> Path to json file </summary>
+        string pathToFile = "http://wttr.in/Plzen,czechia?format=j1";
+        /// <summary> Currently parsed day </summary>
+        DateTime currParsedDay;
+        /// <summary> Sunrise time of currently parsed day </summary>
+        DateTime sunriseTime;
+        /// <summary> Sunset time of currently parsed day </summary>
+        DateTime sunsetTime;
+
+
+        /// <summary>
+        /// Constructor
+        /// </summary>
+        /// <param name="loader"></param>
+        public JsonParser(string pathToFile)
+        {
+            this.pathToFile = pathToFile;
+        }
+
+        /// <summary>
+        /// Downloads json file
+        /// </summary>
+        /// <returns> Path to file </returns>
+        private string DownloadWeatherPrediction()
+        {
+            DateTime now = DateTime.Now;
+            WebClient webClient = new WebClient();
+            webClient.DownloadFile(pathToFile, $"data/{now.Year}{now.Month}{now.Day}.json");
+
+            return $"data/{now.Year}{now.Month}{now.Day}.json";
+        }
+
+        /// <summary>
+        /// Parse weather prediction
+        /// Results is in attributes current for current weather and pred for weather prediction for today, tommorrow and day after tommorrow
+        /// </summary>
+        override public void ParsePrediction()
+        {
+            // TODO ask DataDownloader for download said file and return path to it
+            
+            // get file
+            string file = DownloadWeatherPrediction();
+            DateTime now = DateTime.Now;
+            Console.WriteLine(File.Exists(file));
+
+            current = new WeatherInfo();
+            predictions = new List<WeatherInfo>();
+
+            if (!File.Exists(file))
+                return;
+
+            // read file
+            string data = File.ReadAllText(file);
+
+            // parse
+            JsonDocument doc = JsonDocument.Parse(data);
+            JsonElement root = doc.RootElement;
+            var weatherP = root.EnumerateObject();
+
+            while (weatherP.MoveNext())
+            {
+                string name = weatherP.Current.Name;
+                Console.WriteLine(name);
+
+                switch (name)
+                {
+                    // current weather
+                    case "current_condition":
+                        {
+                            ArrayEnumerator currentWeather = weatherP.Current.Value.EnumerateArray();
+                            current = ParseCurrentWeather(currentWeather);
+
+                            break;
+
+                        }
+                    // weather prediction
+                    case "weather":
+                        {
+                            ArrayEnumerator weather = weatherP.Current.Value.EnumerateArray();
+                            ParseWeatherPredict(weather);
+
+                            break;
+                        }
+                }
+            }
+
+            // sunrise + sunset into data
+            EncompassSunRiseSetTimes();
+
+            TestConsoleOutput();
+        }
+
+        /// <summary>
+        /// Test console output
+        /// </summary>
+        private void TestConsoleOutput()
+        {
+            //Debug.Log(current);
+            //foreach (WeatherInfo w in predictions)
+                //Debug.Log(w);
+        }
+
+        
+
+        /// <summary>
+        /// Change data in a way that they now reflect sunrise and sunset times
+        /// If current time under sunrise or over sunset -> WeatherConditions is Dark
+        /// If prediction time is under sunrise or over sunset and more than half of the interval is under/over said time -> WeatherCondition is Dark
+        /// </summary>
+        private void EncompassSunRiseSetTimes()
+        {
+            // change current weather
+            if ((current.startTime.TimeOfDay > sunsetTime.TimeOfDay) || (current.startTime.TimeOfDay < sunriseTime.TimeOfDay))
+                current.condition = WeatherConditions.Dark;
+
+            // change prediction
+            for (int i = 0; i < predictions.Count - 1; i++)
+            {
+                WeatherInfo w = predictions[i];
+                WeatherInfo wNext = predictions[i + 1];
+
+                // if wNext time < than w time then it is prediction from the next day -> add 24 to correctly calculate timespan
+                int timespan = wNext.startTime.Hour - w.startTime.Hour;
+                if (wNext.startTime.Hour < w.startTime.Hour)
+                    timespan = (wNext.startTime.Hour+24) - w.startTime.Hour;
+                
+                w.intervalLength = timespan;
+
+                // if start under sunset
+                if (w.startTime.TimeOfDay > sunsetTime.TimeOfDay)
+                    w.condition = WeatherConditions.Dark;
+
+                // if start under sunrise
+                if (w.startTime.TimeOfDay < sunriseTime.TimeOfDay)
+                {
+                    double howMuch = ((sunriseTime.Hour * 60 + sunriseTime.Minute) - (w.startTime.Hour * 60 + w.startTime.Minute)) / 60.0;
+
+                    if (howMuch >= timespan / 2.0)
+                        w.condition = WeatherConditions.Dark;
+                }
+
+                // if start under sunrise
+                TimeSpan endTime = new TimeSpan(w.startTime.TimeOfDay.Hours + timespan, w.startTime.TimeOfDay.Minutes, 0);
+                if (endTime > sunsetTime.TimeOfDay)
+                {
+                    double howMuch = ((endTime.Hours * 60 + endTime.Minutes) - (sunsetTime.Hour * 60 + sunsetTime.Minute)) / 60.0;
+
+                    if (howMuch >= timespan / 2.0)
+                        w.condition = WeatherConditions.Dark;
+                }
+            }
+
+            // last prediction
+            WeatherInfo wLast = predictions[predictions.Count - 1];
+            TimeSpan endTimeW = new TimeSpan(24, 0, 0);
+            int timespanLast = endTimeW.Hours - wLast.startTime.Hour;
+            wLast.intervalLength = timespanLast;
+
+            // if start under sunset
+            if (wLast.startTime.TimeOfDay > sunsetTime.TimeOfDay)
+                wLast.condition = WeatherConditions.Dark;
+
+            // if start under sunrise
+            if (wLast.startTime.TimeOfDay < sunriseTime.TimeOfDay)
+            {
+                double howMuch = ((sunriseTime.Hour * 60 + sunriseTime.Minute) - (wLast.startTime.Hour * 60 + wLast.startTime.Minute)) / 60.0;
+
+                if (howMuch >= timespanLast / 2.0)
+                    wLast.condition = WeatherConditions.Dark;
+            }
+
+            // if start under sunrise
+            if (endTimeW > sunsetTime.TimeOfDay)
+            {
+                double howMuch = ((endTimeW.Hours * 60 + endTimeW.Minutes) - (sunsetTime.Hour * 60 + sunsetTime.Minute)) / 60.0;
+
+                if (howMuch >= timespanLast / 2.0)
+                    wLast.condition = WeatherConditions.Dark;
+            }
+        }
+
+        /// <summary>
+        /// Parse weather prediction
+        /// </summary>
+        /// <param name="weather"> ArrayEnumerator of weather predictions </param>
+        private void ParseWeatherPredict(ArrayEnumerator weather)
+        {
+            while (weather.MoveNext())
+            {
+                // prediction for one day
+                var obj = weather.Current.EnumerateObject();
+
+                while (obj.MoveNext())
+                {
+                    switch (obj.Current.Name)
+                    {
+                        case "date":
+                            {
+                                DateTime.TryParseExact(obj.Current.Value.GetString(), "yyyy-MM-dd", CultureInfo.InvariantCulture, DateTimeStyles.None, out currParsedDay);
+                                break;
+                            }
+                        // hourly predictions
+                        case "hourly":
+                            {
+                                ParseHourly(obj.Current.Value.EnumerateArray());
+                                break;
+                            }
+                        // sunset / sunrise hours
+                        case "astronomy":
+                            {
+                                ParseAstronomy(obj.Current.Value.EnumerateArray());
+                                break;
+                            }
+                    }
+                }
+            }
+        }
+
+        /// <summary>
+        /// Parse sunrise and sunset times
+        /// </summary>
+        /// <param name="astronomy"> Astronomy array enumerator </param>
+        private void ParseAstronomy(ArrayEnumerator astronomy)
+        {
+            while (astronomy.MoveNext())
+            {
+                var astrInfo = astronomy.Current.EnumerateObject();
+                
+                while (astrInfo.MoveNext())
+                {
+                    switch (astrInfo.Current.Name)
+                    {
+                        case "sunrise":
+                            {
+                                DateTime.TryParseExact(astrInfo.Current.Value.GetString(), "hh:mm tt", CultureInfo.InvariantCulture, DateTimeStyles.None, out sunriseTime);
+                                Console.WriteLine("\t sunrise time : " + sunriseTime + " " + astrInfo.Current.Value.GetString());
+                                break;
+                            }
+                        case "sunset":
+                            {
+                                DateTime.TryParseExact(astrInfo.Current.Value.GetString(), "hh:mm tt", CultureInfo.InvariantCulture, DateTimeStyles.None, out sunsetTime);
+                                Console.WriteLine("\t sunset time : " + sunsetTime + " " + astrInfo.Current.Value.GetString());
+                                break;
+                            }
+                    }
+                }
+            }
+        }
+
+        /// <summary>
+        /// Parse hourly predictions
+        /// </summary>
+        /// <param name="hourly">Enumerated array of hourly predictions</param>
+        private void ParseHourly(ArrayEnumerator hourly)
+        {
+            while (hourly.MoveNext())
+            {
+                // one hourly prediction
+                var oneH = hourly.Current.EnumerateObject();
+                WeatherInfo weather = new WeatherInfo();
+
+                while (oneH.MoveNext())
+                {
+                    switch (oneH.Current.Name)
+                    {
+                        case "FeelsLikeC":
+                            {
+                                Double.TryParse(oneH.Current.Value.GetString(), out weather.temp);
+                                break;
+                            }
+                        case "cloudcover":
+                            {
+                                int cloudCover;
+                                Int32.TryParse(oneH.Current.Value.GetString(), out cloudCover);
+                                weather.condition = ValueToConditions.CloudCoverToConditions(cloudCover);
+                                break;
+                            }
+                        // take into account highest value from "chanceofrain" and "chaceofsnow"
+                        case "chanceofrain":
+                            {
+                                int rain;
+                                Int32.TryParse(oneH.Current.Value.GetString(), out rain);
+                                weather.rain = rain > weather.rain ? rain : weather.rain;
+                                break;
+                            }
+                        case "chanceofsnow":
+                            {
+                                int snow;
+                                Int32.TryParse(oneH.Current.Value.GetString(), out snow);
+                                weather.rain = snow > weather.rain ? snow : weather.rain;
+                                break;
+                            }
+                        // wind kmph has to be translated to mps
+                        case "WindGustKmph":
+                            {
+                                double windkmh;
+                                Double.TryParse(oneH.Current.Value.GetString(), out windkmh);
+                                weather.wind= windkmh * 1000 / (60.0*60.0);
+                                break;
+                            }
+                        case "time":
+                            {
+                                int h;
+                                Int32.TryParse(oneH.Current.Value.GetString(), out h);
+                                h /= 100;
+                                DateTime time = new DateTime(currParsedDay.Year, currParsedDay.Month, currParsedDay.Day, h, 0, 0);
+                                weather.startTime = time;
+                                break;
+                            }
+                    }
+                }
+
+                // Console.WriteLine(weather.ToString());
+                predictions.Add(weather);
+
+            }
+
+        }
+
+        /// <summary>
+        /// Parse current weather
+        /// </summary>
+        /// <param name="currentWeather">Enumerated hour of weather data</param>
+        /// <returns>WeatherInfo with current weather</returns>
+        private WeatherInfo ParseCurrentWeather(ArrayEnumerator currentWeather)
+        {
+            WeatherInfo res = new WeatherInfo();
+            //res.current = true;
+
+            while (currentWeather.MoveNext())
+            {
+                var obj = currentWeather.Current.EnumerateObject();
+
+                while (obj.MoveNext())
+                {
+                    switch (obj.Current.Name)
+                    {
+                        case "localObsDateTime":
+                            {
+                                DateTime.TryParse(obj.Current.Value.GetString(), out res.startTime);
+                                break;
+                            }
+                        case "FeelsLikeC":
+                            {
+                                Double.TryParse(obj.Current.Value.GetString(), out res.temp);
+                                break;
+                            }
+                        case "cloudcover":
+                            {
+                                int cloudCover;
+                                Int32.TryParse(obj.Current.Value.GetString(), out cloudCover);
+                                res.condition = ValueToConditions.CloudCoverToConditions(cloudCover);
+                                break;
+                            }
+                        case "precipMM":
+                            {
+                                double rainMM;
+                                Double.TryParse(obj.Current.Value.GetString(), out rainMM);
+                                res.rain = rainMM > 0 ? 100 : 0;
+                                break;
+                            }
+                        case "windspeedKmph":
+                            {
+                                double wind;
+                                Double.TryParse(obj.Current.Value.GetString(), out wind);
+                                res.wind = wind * 1000 / (60.0 * 60.0);
+                                break;
+                            }
+                    }
+                }
+
+            }
+
+            return res;
+        }
+
+    }
+}
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs.meta b/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs.meta
new file mode 100644
index 0000000..16a0677
--- /dev/null
+++ b/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: da78076da8fec354bb7e2bee645e857d
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
